goldenratio = 1.618003399;
joinfactor=0.25;

gDefaultThickness = 4;
gDefaultWidth = 48;     // 42 is nema 17 size, but I want taller for bottom bolt clearance
gDefaultDepth = 43;     // 42 is nema 17 size
gDefaultHeight = 38;

gDefaultMountHoleRadius = 3/2;
gDefaultMountSlotLength = 10;

gNema17MountDiagonal = 43;

wall_thick=3.5;
inside_width=42;
inside_depth=37;
inside_height=142;
sz=20;


//main();
//noz();
//clip();
laser_mount();
//laser_holder(12, 30);

module laser_mount()
{
	lasmod_dia=12;
	lasmod_len=30;
//12*30, 8*13, 6*10

	difference(){
	
		union(){
			translate([0,13,-2]) {
				cube([50,62,4],center=true);
				cube([15,80,4],center=true);
			}				
//			translate([0,-28,-lasmod_dia]) rotate([90+25,0,0]) laser_holder(12, 30);
//			translate([0,54,-lasmod_dia]) rotate([90-25,0,0]) laser_holder(12, 30);
//			translate([0,-28+3,-lasmod_dia+3]) rotate([90+25,0,0]) laser_holder(8, 13);
//			translate([0,54-3,-lasmod_dia+3]) rotate([90-25,0,0]) laser_holder(8, 13);
			translate([0,-28+4,-lasmod_dia+5]) rotate([90+25,0,0]) laser_holder(6, 10);
			translate([0,54-4,-lasmod_dia+5]) rotate([90-25,0,0]) laser_holder(6, 10);
		}
		union(){
			rod();
			translate([0,26,0]) noz();

			translate([0,0,0]) rotate([0,0,0]) cylinder(h=10,r=10,center=true,$fn=20);
			translate([0,26,0]) rotate([0,0,0]) cylinder(h=10,r=10,center=true,$fn=20);

			translate([0,13,-11])  cube([50,62,14],center=true);
			translate([0,13,-14])  cube([2,120,14],center=true);
			translate([23,13,-4]) {
				cube([19,30,3],center=true);
			}				
		}
	}
}
module laser_holder(lasmod_dia, lasmod_len)
{
//	cube(10);
	difference(){
		cylinder(h=lasmod_len,r=lasmod_dia/2+2.5,center=true,$fn=20);
		cylinder(h=lasmod_len+.01,r=lasmod_dia/2,center=true,$fn=20);

	}

}


module main(){
	
	difference(){
		union(){
			rod();
			translate([0,26,0]) noz();
			translate([inside_width/2+2,-inside_depth/2,20]) rotate([-90,0,0]) clip();			
			translate([inside_width/2+2,-inside_depth/2,80]) rotate([-90,0,0]) clip();
			translate([inside_width/2+2,-inside_depth/2,145]) rotate([-90,0,0]) clip();

			translate([-inside_width/2-2,-inside_depth/2,0]) rotate([-90,180,0]) clip();			
			translate([-inside_width/2-2,-inside_depth/2,60]) rotate([-90,180,0]) clip();
			translate([-inside_width/2-2,-inside_depth/2,125]) rotate([-90,180,0]) clip();


		}
		translate([0,0,34.35]) rotate([0,90,0])
			for(i=[-11.85,11.85]) for(j=[-6.35,6.35]) translate([j,i,0]) cylinder(h=120, r=3.25/2, center=true);
			translate([0,15,15]) rotate([45,0,0]) cube([50,sz-5,sz-5],center=true);
			translate([0,15,50]) rotate([45,0,0]) cube([50,sz,sz],center=true);
			translate([0,15,90]) rotate([45,0,0]) cube([50,sz,sz],center=true);
			translate([0,15,130]) rotate([45,0,0]) cube([50,sz-5,sz-5],center=true);

		translate([0,0,140]) rotate([0,90,0]) cylinder(h=120, r=3.25/2, center=true);
		
	}
}
module clip(){
	difference(){
		union(){
			cube([20,20,4]);
			cube([4,20,20]);
		}
		translate([12,10,0]) cylinder(10,r=3.3);
	}

}


module noz(){
	difference(){
		union(){
			translate([0,0,145.5]) nema17shaftplate(5);
			translate([0,0,-8.5]) cylinder(10,6.5,15);

			translate([0,0,wall_thick/2]) cube([inside_width+2*wall_thick,inside_depth,wall_thick],center=true);

			translate([-inside_width/2-wall_thick/2,0,inside_height/2+wall_thick/2]) cube([wall_thick,inside_depth,inside_height+wall_thick],center=true);
			translate([inside_width/2+wall_thick/2,0,inside_height/2+wall_thick/2]) cube([wall_thick,inside_depth,inside_height+wall_thick],center=true);
		}
		translate([0,0,0]) cylinder(h=37, r=4,center=true);
	}

}

module rod(){

	difference(){	
		union(){
			translate([0,0,wall_thick/2]) cube([inside_width+2*wall_thick,inside_depth,wall_thick],center=true);
			translate([0,-7,wall_thick+inside_height]) cube([inside_width+2*wall_thick,inside_depth-14,wall_thick],center=true);
	
			translate([-inside_width/2-wall_thick/2,0,inside_height/2+wall_thick/2]) cube([wall_thick,inside_depth,inside_height+wall_thick],center=true);
			translate([inside_width/2+wall_thick/2,0,inside_height/2+wall_thick/2]) cube([wall_thick,inside_depth,inside_height+wall_thick],center=true);
	
			translate([0,0,-8.5]) cylinder(10,5,15);
		}
	
		translate([0,0,89]) rotate([90,0,0]) cylinder(h=120, r=3.25/2, center=true);
		translate([0,0,140]) rotate([0,90,0]) cylinder(h=120, r=3.25/2, center=true);
		translate([0,0,0]) cylinder(h=37, r=2,center=true);
	}
	
}

module nema17shaftplate(thickness)
{
	mountHoleRadius = 3/2;
	mountRadius = gNema17MountDiagonal/2;

	shaftcollarradius = 11;

	difference()
	{
		cube(size=[gDefaultWidth, gDefaultDepth, thickness], center=true);
		// Subtract a circle for the collar around the shaft
		cylinder(r=shaftcollarradius, h=thickness+2*joinfactor, center=true);

		// Create the mounting holes
		for(hole=[0:3])
		{
			rotate([0,0,(hole*90)+45])
			translate([mountRadius, 0, 0])
			cylinder(r=mountHoleRadius, h=thickness+2*joinfactor, center=true);
		}
	}
}
